#include "main.h"

void OwHiZ(void)		//prisili RA0 v visoko impedanno stanje
{
	TRISA=1;
}

void OwLow(void)		//prisili RA0 v nizko logino stanje
{
	DS=0;
	TRISA=0;
}

void OwInit(void)	//Reset DS1820
{
	OwHiZ();
	pdbyte=0;
	OwLow();
	__delay_us(500);
	OwHiZ();
	__delay_us(70);
	if(DS==0)
		pdbyte=1;
	__delay_us(430);	
}

void OwPoslji(unsigned char com)	//poiljanje komande DS1820
{
	pdbyte=com;
	for(i=0;i<9;i++)
	{		
		OwLow();
		__delay_us(3);		
		pdbyte=com&0x1;
		com>>=1;
		if(pdbyte){
			OwHiZ();
			__delay_us(60);
			__delay_us(2);
		}
		else{
			__delay_us(60);
			OwHiZ();
			__delay_us(2);		
		}
	}
}

unsigned char OwBeri(void)	//branje podatka z 1-wire vodila
{
	unsigned char data=0;
	for(i=0;i<9;i++)
	{
		OwLow();
		__delay_us(5);
		OwHiZ();
		__delay_us(5);
		pdbyte=DS;
		__delay_us(50);
		data=data>>1;
		if(pdbyte)
		{
			data+=0x80;
		}
		__delay_us(5);
	}
	__delay_us(5);
	return data;
}