#include "main.h"
#include "lcd.h"
#include "1Wire.h"

__CONFIG(XT & WDTDIS & PWRTEN & UNPROTECT);

void init(void)
{	
	pin=1;
	INTCON=0x90;	//Zunanje prekinitve-RB0-osvetlitev zaslona
	OPTION=0x80;	//RBO-prekinitev ob spremembi iz visokega v nizek nivo
	TRISB=1;		//RB0-vhod za tipko-osvetlitev zaslona
	TRISA=1;		//RA0-vhod (Visoko impedanno stanje-pullup upor na +5v)
	PORTA=0;
	PORTB=0;
}

void main(void)
{
	float t;
	init();			//Init PIC
	lcd_init();		//Init LCD	
	OwInit();		//Init DS1820
	OwPoslji(SKPROM);	//Skip-rom komanda
	OwPoslji(RR);		//Read rom komanda
	OwInit();		//Init DS1820
	OwPoslji(SKPROM);	//Skip-rom komanda
	OwPoslji(RS);		//Read-scrachpad komanda
	vrednost.bajti.msb=OwBeri();	//branje zgornjih 8 bitov
	vrednost.bajti.lsb=OwBeri();	//branje spodnjih 8 bitov
		
	t=(float)vrednost.temp/2.0;		//izraun temperature
	__delay_ms(200);
	lcd_puts((unsigned char*)t);	//izpis temperature
}

void interrupt isr()	//prekinitvena rutina za vklop lcd osvetlitve
{	
	if(RB0==0){
		__delay_ms(10);
		if(RB0==1)
			pin=0;	
	}
	else
		pin=1;

	if(pin==0)
		RB1=1;
}